'$INCLUDE: 'qbobject.bi'
'This program demonstrate how to use the SetProperties command.
'You may point the cursor to an object or object controller and press F1 for parameters.

DIM cmblist(10) AS STRING
FOR a = 1 TO 10
  cmblist(a) = "List" + STR$(a)
NEXT

DIM list1(20) AS STRING
FOR a = 1 TO 10
  list1(a) = "List" + STR$(a)
NEXT

DIM editor(20) AS STRING


ON ERROR GOTO errors  'goto errors if error occured

win 100, 50, 500, 450, 0, "Set Properties Example", 7, 1, 7, 1, 1

button "_Button", 200, 100, 400, 130, buttonid
textbox "_Text Box:", 5, 200, 140, 10, textboxid
putchar "Text box", textboxid
text$ = "Text box"

combobox "_Combo Box:", 5, 200, 175, 20, comboboxid
spinbox "_Spin box:", 5, 415, 280, 4, spinid
checkbox "C_heck box 1", 200, 210, 5, chk1id
checkbox "Chec_k box 2", 200, 245, 5, chk2id
chk1 = 1
check chk1id

lists(1) = " Option 1"
lists(2) = " Option 2"
optioncirc 2, 200, 280, 5, 10, 0, optid
opt = 2
setoption 2, optid

editbox 130, 320, 5, 15, editor(), editorid
listbox 320, 320, 5, 15, list1(), list1id

'Note that the above objects uses default properties.

'To change the properties of an object, specify setproperties
'then the object.

LOCATE 1
PRINT "This is the default properties. You may press ENTER to proceed..."

waitkey CHR$(13) 'wait for ENTER to be hit

LOCATE 1
PRINT SPACE$(79)

LINE (110, 80)-(490, 440), 7, BF 'erase our working window

setproperties buttonid, 14, 0, 1, 4, 4
button "_Button", 200, 100, 400, 130, buttonid

setproperties textboxid, 1, 4, 15, 5, 1
textbox "_Text Box:", 5, 200, 140, 10, textboxid
putchar "Text box", textboxid


setproperties comboboxid, 6, 1, 14, 4, 9
combobox "_Combo Box:", 5, 200, 175, 20, comboboxid

setproperties spinid, 9, 5, 7, 7, 0
spinbox "_Spin box:", 5, 415, 280, 4, spinid

setproperties chk1id, 5, 1, 15, 7, 0
checkbox "C_heck box 1", 200, 210, 5, chk1id

setproperties chk2id, 6, 4, 15, 7, 0
checkbox "Chec_k box 2", 200, 245, 5, chk2id

'check our first check box
chk1 = 1
check chk1id

setproperties optid, 5, 9, 7, 1, 6
lists(1) = " Option 1"
lists(2) = " Option 2"
optioncirc 2, 200, 280, 5, 10, 0, optid

'set second option
opt = 2
setoption 2, optid

setproperties editorid, 0, 7, 1, 0, 6
'                                ^ field effect has no effect with editbox, listbox and pageframe.
'                       ^ field color has no effect with editbox, listbox and pageframe.

editbox 130, 320, 5, 15, editor(), editorid
	
setproperties list1id, 0, 0, 15, 0, 6
listbox 320, 320, 5, 15, list1(), list1id

setgridlinefocus 0 'turn off grid line focus
setfocus buttonid
DO
  'control for buttonid
   button1 = Button.Cont(buttonid)
  
   'control for textboxid
   text.cont text$, 20, textboxid

   'control for comboboxid
   combo.cont combo$, cmblist(), 20, 1, 5, 1, 0, 15, 15, 12, comboboxid

   spin.cont spin$, 0, 9999, 1, spinid

   check.cont chk1, chk1id
   check.cont chk2, chk2id
 
   option.cont opt, 2, optid

   edit.cont editor(), editorid
 
   listchoose$ = List.Cont(list1(), 15, 8, list1id)
 
  'Exit when ESC was pressed or window close button was clicked.
  IF Click(2) OR key$ = CHR$(27) OR INKEY$ = CHR$(27) THEN EXIT DO

  'Click ,drag, and alt keys trapping. Must be the last line among all controls.
  getcontrol

LOOP
FREEXMS  'frees XMS handles. Extremely important
END

errors:
FREEXMS 'frees XMS handles. Extremely important
ERROR ERR 'show error

